<?xml version="1.0"?>

# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

<?xml-stylesheet href="chrome://browser/content/places/places.css"?>

<?xml-stylesheet href="chrome://global/skin/global.css"?>
<?xml-stylesheet href="chrome://browser/skin/places/tree-icons.css"?>
<?xml-stylesheet href="chrome://browser/skin/places/organizer.css"?>
<?xml-stylesheet href="chrome://browser/skin/places/editBookmark.css"?>

<?xml-stylesheet href="chrome://browser/content/downloads/downloads.css"?>
<?xml-stylesheet href="chrome://browser/skin/downloads/allDownloadsView.css"?>

<!DOCTYPE window [
<!ENTITY % placesDTD SYSTEM "chrome://browser/locale/places/places.dtd">
%placesDTD;
<!ENTITY % editMenuOverlayDTD SYSTEM "chrome://global/locale/editMenuOverlay.dtd">
%editMenuOverlayDTD;
<!ENTITY % browserDTD SYSTEM "chrome://browser/locale/browser.dtd">
%browserDTD;
<!ENTITY % editBookmarkOverlayDTD SYSTEM "chrome://browser/locale/places/editBookmarkOverlay.dtd">
%editBookmarkOverlayDTD;
#ifdef XP_MACOSX
#include ../../../base/content/browser-doctype.inc
#endif
]>

<window id="places"
        title="&places.library.title;"
        windowtype="Places:Organizer"
        xmlns="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul"
        xmlns:html="http://www.w3.org/1999/xhtml"
        onload="PlacesOrganizer.init();"
        onunload="PlacesOrganizer.destroy();"
        width="&places.library.width;" height="&places.library.height;"
        screenX="10" screenY="10"
        toggletoolbar="true"
        persist="width height screenX screenY sizemode">

  <linkset>
    <html:link rel="localization" href="toolkit/global/textActions.ftl"/>
    <html:link rel="localization" href="browser/browserSets.ftl"/>
    <html:link rel="localization" href="browser/downloads.ftl"/>
  </linkset>

  <script src="chrome://browser/content/places/places.js"/>
  <script src="chrome://global/content/editMenuOverlay.js"/>
#ifndef XP_MACOSX
  <!-- On Mac, this is included via macWindow.inc.xhtml -> global-scripts.inc -> browser.js -> defineLazyScriptGetter -->
  <script src="chrome://browser/content/places/editBookmark.js"/>
  <!-- On Mac, thes are included via macWindow.inc.xhtml -> global-scripts.inc -->
  <script src="chrome://global/content/globalOverlay.js"/>
  <script src="chrome://browser/content/utilityOverlay.js"/>
#endif

  <stringbundleset id="placesStringSet">
    <stringbundle id="brandStrings" src="chrome://branding/locale/brand.properties"/>
  </stringbundleset>

#ifdef XP_MACOSX
#include ../../../base/content/macWindow.inc.xhtml
#else
#include placesCommands.inc.xhtml
#endif

  <!-- This must be included after macWindow.inc.xhtml to override DownloadsView -->
  <script src="chrome://browser/content/downloads/allDownloadsView.js"/>
  <script src="chrome://global/content/contentAreaUtils.js"/>
  <script src="chrome://browser/content/places/places-tree.js"/>

  <commandset id="organizerCommandSet">
    <command id="OrganizerCommand_find:all"
             oncommand="PlacesSearchBox.findAll();"/>
    <command id="OrganizerCommand_export"
             oncommand="PlacesOrganizer.exportBookmarks();"/>
    <command id="OrganizerCommand_import"
             oncommand="PlacesOrganizer.importFromFile();"/>
    <command id="OrganizerCommand_browserImport"
             oncommand="PlacesOrganizer.importFromBrowser();"/>
    <command id="OrganizerCommand_backup"
             oncommand="PlacesOrganizer.backupBookmarks();"/>
    <command id="OrganizerCommand_restoreFromFile"
             oncommand="PlacesOrganizer.onRestoreBookmarksFromFile();"/>
    <command id="OrganizerCommand_search:save"
             oncommand="PlacesOrganizer.saveSearch();"/>
    <command id="OrganizerCommand_search:moreCriteria"
             oncommand="PlacesQueryBuilder.addRow();"/>
    <command id="OrganizerCommand:Back"
             oncommand="PlacesOrganizer.back();"/>
    <command id="OrganizerCommand:Forward"
             oncommand="PlacesOrganizer.forward();"/>
  </commandset>
#include ../../downloads/content/downloadsCommands.inc.xhtml

  <keyset id="placesOrganizerKeyset">
    <!-- Instantiation Keys -->
    <key id="placesKey_close" key="&cmd.close.key;" modifiers="accel"
         oncommand="window.close();"/>

    <!-- Command Keys -->
    <key id="placesKey_find:all"
         command="OrganizerCommand_find:all"
         key="&cmd.find.key;"
         modifiers="accel"/>

    <!-- Back/Forward Keys Support -->
#ifndef XP_MACOSX
    <key id="placesKey_goBackKb"
         keycode="VK_LEFT"
         command="OrganizerCommand:Back"
         modifiers="alt"/>
    <key id="placesKey_goForwardKb"
         keycode="VK_RIGHT"
         command="OrganizerCommand:Forward"
         modifiers="alt"/>
#else
    <key id="placesKey_goBackKb"
         keycode="VK_LEFT"
         command="OrganizerCommand:Back"
         modifiers="accel"/>
    <key id="placesKey_goForwardKb"
         keycode="VK_RIGHT"
         command="OrganizerCommand:Forward"
         modifiers="accel"/>
#endif
#ifdef XP_UNIX
    <key id="placesKey_goBackKb2"
         data-l10n-id="nav-back-shortcut-alt"
         command="OrganizerCommand:Back"
         modifiers="accel"/>
    <key id="placesKey_goForwardKb2"
         data-l10n-id="nav-fwd-shortcut-alt"
         command="OrganizerCommand:Forward"
         modifiers="accel"/>
#endif
  </keyset>

#include ../../../../toolkit/content/editMenuKeys.inc.xhtml
#ifdef XP_MACOSX
  <keyset id="editMenuKeysExtra">
    <key id="key_delete2" keycode="VK_BACK" command="cmd_delete"/>
  </keyset>
#endif

  <popupset id="placesPopupset">
#include placesContextMenu.inc.xhtml
    <menupopup id="placesColumnsContext"
               onpopupshowing="ViewMenu.fillWithColumns(event, null, null, 'checkbox', null);"
               oncommand="ViewMenu.showHideColumn(event.target); event.stopPropagation();"/>
#include ../../downloads/content/downloadsContextMenu.inc.xhtml
  </popupset>

  <toolbox id="placesToolbox">
    <toolbar class="chromeclass-toolbar" id="placesToolbar" align="center">
      <toolbarbutton id="back-button"
                     command="OrganizerCommand:Back"
                     tooltiptext="&backButton.tooltip;"
                     disabled="true"/>

      <toolbarbutton id="forward-button"
                     command="OrganizerCommand:Forward"
                     tooltiptext="&forwardButton.tooltip;"
                     disabled="true"/>

#ifdef XP_MACOSX
        <toolbarbutton type="menu" class="tabbable"
              onpopupshowing="document.getElementById('placeContent').focus()"
#else
      <menubar id="placesMenu">
        <menu accesskey="&organize.accesskey;" class="menu-iconic"
#endif
              id="organizeButton" label="&organize.label;"
              tooltiptext="&organize.tooltip;">
          <menupopup id="organizeButtonPopup">
            <menuitem id="newbookmark"
                      command="placesCmd_new:bookmark"
                      label="&cmd.new_bookmark.label;"
                      accesskey="&cmd.new_bookmark.accesskey;"/>
            <menuitem id="newfolder"
                      command="placesCmd_new:folder"
                      label="&cmd.new_folder.label;"
                      accesskey="&cmd.new_folder.accesskey;"/>
            <menuitem id="newseparator"
                      command="placesCmd_new:separator"
                      label="&cmd.new_separator.label;"
                      accesskey="&cmd.new_separator.accesskey;"/>

#ifdef XP_MACOSX
            <menuseparator id="orgDeleteSeparator"/>

            <menuitem id="orgDelete"
                      command="cmd_delete"
                      data-l10n-id="text-action-delete"
                      key="key_delete"/>
#else
            <menuseparator id="orgUndoSeparator"/>

            <menuitem id="orgUndo"
                      command="cmd_undo"
                      data-l10n-id="text-action-undo"
                      key="key_undo"/>
            <menuitem id="orgRedo"
                      command="cmd_redo"
                      data-l10n-id="text-action-redo"
                      key="key_redo"/>

            <menuseparator id="orgCutSeparator"/>

            <menuitem id="orgCut"
                      command="cmd_cut"
                      data-l10n-id="text-action-cut"
                      key="key_cut"
                      selection="separator|link|folder|mixed"/>
            <menuitem id="orgCopy"
                      command="cmd_copy"
                      data-l10n-id="text-action-copy"
                      key="key_copy"
                      selection="separator|link|folder|mixed"/>
            <menuitem id="orgPaste"
                      command="cmd_paste"
                      data-l10n-id="text-action-paste"
                      key="key_paste"
                      selection="mutable"/>
            <menuitem id="orgDelete"
                      command="cmd_delete"
                      data-l10n-id="text-action-delete"
                      key="key_delete"/>

            <menuseparator id="selectAllSeparator"/>

            <menuitem id="orgSelectAll"
                      command="cmd_selectAll"
                      data-l10n-id="text-action-select-all"
                      key="key_selectAll"/>

            <menuseparator id="orgCloseSeparator"/>

            <menuitem id="orgClose"
                      key="placesKey_close"
                      label="&file.close.label;"
                      accesskey="&file.close.accesskey;"
                      oncommand="window.close();"/>
#endif
          </menupopup>
#ifdef XP_MACOSX
        </toolbarbutton>
        <toolbarbutton type="menu" class="tabbable"
#else
        </menu>
        <menu accesskey="&views.accesskey;" class="menu-iconic"
#endif
              id="viewMenu" label="&views.label;"
              tooltiptext="&views.tooltip;">
          <menupopup id="viewMenuPopup">

            <menu id="viewColumns"
                  label="&view.columns.label;" accesskey="&view.columns.accesskey;">
              <menupopup onpopupshowing="ViewMenu.fillWithColumns(event, null, null, 'checkbox', null);"
                         oncommand="ViewMenu.showHideColumn(event.target); event.stopPropagation();"/>
            </menu>

            <menu id="viewSort" label="&view.sort.label;"
                  accesskey="&view.sort.accesskey;">
              <menupopup onpopupshowing="ViewMenu.populateSortMenu(event);"
                         oncommand="ViewMenu.setSortColumn(event.target.column, null);">
                <menuitem id="viewUnsorted" type="radio" name="columns"
                          label="&view.unsorted.label;" accesskey="&view.unsorted.accesskey;"
                          oncommand="ViewMenu.setSortColumn(null, null);"/>
                <menuseparator id="directionSeparator"/>
                <menuitem id="viewSortAscending" type="radio" name="direction"
                          label="&view.sortAscending.label;" accesskey="&view.sortAscending.accesskey;"
                          oncommand="ViewMenu.setSortColumn(null, 'ascending'); event.stopPropagation();"/>
                <menuitem id="viewSortDescending" type="radio" name="direction"
                          label="&view.sortDescending.label;" accesskey="&view.sortDescending.accesskey;"
                          oncommand="ViewMenu.setSortColumn(null, 'descending'); event.stopPropagation();"/>
              </menupopup>
            </menu>
          </menupopup>
#ifdef XP_MACOSX
        </toolbarbutton>
        <toolbarbutton type="menu" class="tabbable"
#else
        </menu>
        <menu accesskey="&maintenance.accesskey;" class="menu-iconic"
#endif
              id="maintenanceButton" label="&maintenance.label;"
              tooltiptext="&maintenance.tooltip;">
          <menupopup id="maintenanceButtonPopup">
            <menuitem id="backupBookmarks"
                      command="OrganizerCommand_backup"
                      label="&cmd.backup.label;"
                      accesskey="&cmd.backup.accesskey;"/>
            <menu id="fileRestoreMenu" label="&cmd.restore2.label;"
                      accesskey="&cmd.restore2.accesskey;">
              <menupopup id="fileRestorePopup" onpopupshowing="PlacesOrganizer.populateRestoreMenu();">
                <menuitem id="restoreFromFile"
                          command="OrganizerCommand_restoreFromFile"
                          label="&cmd.restoreFromFile.label;"
                          accesskey="&cmd.restoreFromFile.accesskey;"/>
              </menupopup>
            </menu>
            <menuseparator/>
            <menuitem id="fileImport"
                      command="OrganizerCommand_import"
                      label="&importBookmarksFromHTML.label;"
                      accesskey="&importBookmarksFromHTML.accesskey;"/>
            <menuitem id="fileExport"
                      command="OrganizerCommand_export"
                      label="&exportBookmarksToHTML.label;"
                      accesskey="&exportBookmarksToHTML.accesskey;"/>
            <menuseparator/>
            <menuitem id="browserImport"
                      command="OrganizerCommand_browserImport"
                      label="&importOtherBrowser.label;"
                      accesskey="&importOtherBrowser.accesskey;"/>
          </menupopup>
#ifdef XP_MACOSX
        </toolbarbutton>
#else
        </menu>
      </menubar>
#endif

      <toolbarbutton id="clearDownloadsButton"
                          data-l10n-id="downloads-clear-downloads-button"
                          class="tabbable"
                          command="downloadsCmd_clearDownloads"/>

      <spacer id="libraryToolbarSpacer" flex="1"/>

      <search-textbox id="searchFilter"
                      flex="1"
                      aria-controls="placeContent"
                      oncommand="PlacesSearchBox.search(this.value);"
                      collection="bookmarks"/>
    </toolbar>
  </toolbox>

  <hbox flex="1" id="placesView">
    <tree id="placesList"
          class="plain placesTree"
          is="places-tree"
          hidecolumnpicker="true" context="placesContext"
          onselect="PlacesOrganizer.onPlaceSelected(true);"
          onclick="PlacesOrganizer.onPlacesListClick(event);"
          onfocus="PlacesOrganizer.updateDetailsPane(event);"
          seltype="single"
          persist="width"
          width="200"
          minwidth="100"
          maxwidth="400">
      <treecols>
        <treecol anonid="title" flex="1" primary="true" hideheader="true"/>
      </treecols>
      <treechildren flex="1"/>
    </tree>
    <splitter collapse="none" persist="state"></splitter>
    <vbox id="contentView" flex="4">
      <deck id="placesViewsDeck"
            selectedIndex="0"
            flex="1">
        <tree id="placeContent"
              class="plain placesTree"
              context="placesContext"
              hidecolumnpicker="true"
              flex="1"
              is="places-tree"
              flatList="true"
              selectfirstnode="true"
              enableColumnDrag="true"
              onfocus="PlacesOrganizer.updateDetailsPane(event)"
              onselect="PlacesOrganizer.updateDetailsPane(event)"
              onkeypress="ContentTree.onKeyPress(event);">
          <treecols id="placeContentColumns" context="placesColumnsContext">
            <!--
              The below code may suggest that 'ordinal' is still a supported XUL
              attribute. It is not. This is a crutch so that we can continue
              persisting the CSS -moz-box-ordinal-group attribute, which is the
              appropriate replacement for the ordinal attribute but cannot yet
              be easily persisted. The code that synchronizes the attribute with
              the CSS lives in toolkit/content/widget/tree.js and is specific to
              tree elements.
            -->
            <treecol label="&col.name.label;" id="placesContentTitle" anonid="title" flex="5" primary="true" ordinal="1"
                      persist="width hidden ordinal sortActive sortDirection"/>
            <splitter class="tree-splitter"/>
            <treecol label="&col.tags.label;" id="placesContentTags" anonid="tags" flex="2"
                      persist="width hidden ordinal sortActive sortDirection"/>
            <splitter class="tree-splitter"/>
            <treecol label="&col.url.label;" id="placesContentUrl" anonid="url" flex="5"
                      persist="width hidden ordinal sortActive sortDirection"/>
            <splitter class="tree-splitter"/>
            <treecol label="&col.mostrecentvisit.label;" id="placesContentDate" anonid="date" flex="1" hidden="true"
                      persist="width hidden ordinal sortActive sortDirection"/>
            <splitter class="tree-splitter"/>
            <treecol label="&col.visitcount.label;" id="placesContentVisitCount" anonid="visitCount" flex="1" hidden="true"
                      persist="width hidden ordinal sortActive sortDirection"/>
            <splitter class="tree-splitter"/>
            <treecol label="&col.dateadded.label;" id="placesContentDateAdded" anonid="dateAdded" flex="1" hidden="true"
                      persist="width hidden ordinal sortActive sortDirection"/>
            <splitter class="tree-splitter"/>
            <treecol label="&col.lastmodified.label;" id="placesContentLastModified" anonid="lastModified" flex="1" hidden="true"
                      persist="width hidden ordinal sortActive sortDirection"/>
          </treecols>
          <treechildren flex="1" onclick="ContentTree.onClick(event);"/>
        </tree>
        <richlistbox flex="1"
                     seltype="multiple"
                     id="downloadsRichListBox"
                     context="downloadsContextMenu"/>
      </deck>
      <deck id="detailsDeck" style="height: 11em;">
        <vbox id="itemsCountBox" align="center">
          <spacer flex="3"/>
          <label id="itemsCountText"/>
          <spacer flex="1"/>
          <description id="selectItemDescription">
              &detailsPane.selectAnItemText.description;
          </description>
          <spacer flex="3"/>
        </vbox>
        <vbox id="infoBox">
#include editBookmarkPanel.inc.xhtml
        </vbox>
      </deck>
    </vbox>
  </hbox>
</window>
